/*
PhillipskurveMultiplikator kap10.ox.

Beregner multiplikatorer for Phillipskurven
*/

//#pragma array_base(1)
#include <oxstd.h>
#include <oxdraw.h>

/*
Ox-rutine for  beregne interimmultiplikatorer

Gunnar Brdsen og Ragnar Nymoen
03.03.2011
*/

main()
{
//Vektor med 9 autoregressive koeffisienter, dvs 0.2 0.33 osv.
decl a = <.748297, 0, 0, 0, 0, 0, 0, 0, 0>';

//Vektor med 9 distribuert lag koeffisientar
decl b = <-0.656805,0,0,0,0,0,0,0,0,0>';

decl s, a1, a2, a3, a4, a5, a6, a7, a8,
	b0, b1, b2, b3, b4, b5, b6, b7, b8,median,
	lagk0,lagk1,lagk2, lagk3, lagk4, lagk5, lagk6, lagk7, lagk8, lagk,
	z, lagk100, im100, lrm, stim100, 
	int100, int20, lagk50, stimmed, lrm100, imlrm100,
	imlrm50, stimme50, imstimme, i, x;
 
    
    
 
	print("autoregressiv del",a', "distribuert lag del", b');
    
	a1 = a[0];
    a2 = a[1];
    a3 = a[2];
    a4 = a[3];
    a5 = a[4];
    a6 = a[5];
    a7 = a[6];
    a8 = a[7];
    
                     /*...og her */
    b0 = b[0];
    b1 = b[1];
    b2 = b[2];
    b3 = b[3];
    b4 = b[4];
    b5 = b[5];
    b6 = b[6];
    b7 = b[7];
    b8 = b[8];
    
    lagk0 = b0;
    lagk1 = a1 * lagk0 + b1;
    lagk2 = a1 * lagk1 + a2 * lagk0 + b2;
    lagk3 = a1 * lagk2 + a2 * lagk1 + a3 * lagk0 + b3;                 /*...og her */
    lagk4 = a1 * lagk3 + a2 * lagk2 + a3 * lagk1 + a4 * lagk0 + b4;
    lagk5 = a1 * lagk4 + a2 * lagk3 + a3 * lagk2 + a4 * lagk1 + a5 * lagk0 + b5;
    lagk6 = a1 * lagk5 + a2 * lagk4 + a3 * lagk3 + a4 * lagk2 + a5 * lagk1 + a6 * lagk0 + b6;
    lagk7 = a1 * lagk6 + a2 * lagk5 + a3 * lagk4 + a4 * lagk3 + a5 * lagk2 + a6 * lagk1 + a7 * lagk0 + b7;
    lagk8 = a1 * lagk7 + a2 * lagk6 + a3 * lagk5 + a4 * lagk4 + a5 * lagk3 + a6 * lagk2 + a7 * lagk1 + a8 * lagk0 + b8;
    
    lagk = lagk0 | lagk1 | lagk2 | lagk3 | lagk4 | lagk5 | lagk6 | lagk7 | lagk8;  /*...og her*/
    
    z = zeros(100, 1);

    lagk100 = cumsum(z, a', lagk);
    
    im100 = cumulate(lagk100);                      /*interimmultiplikatorene*/
    
    lrm = sumc(b) / (1 - sumc(a));                /*langtidsmultiplikatoren*/
    
    stim100 = im100 / lrm;               /*standardiserte interimmultiplikatorer*/

    int100 = lagk100 ~ im100 ~ stim100;
    

	print("Langtidsmultiplikatoren er:" ,lrm,"\n");

    print("De 20 foerste dynamiske multiplikatorene, interimmultiplikatorene og standardiserte interimmult",int100[0:19][]);
    
    
    median = 0.5 * ones(100, 1);            /*0.5-linjen*/
    stimmed = stim100 ~ median;       /*standardiserte interimmult. & 0.5-linjen*/
    lrm100 = lrm * ones(100, 1);
    imlrm100 = im100 ~ lrm100;               /*interimmult. & langtidsmult.*/
    
    
    DrawT(0, b', 0, 1, 1);
    DrawTitle(0, "Impulsfordeling (d-lagget)");
	DrawT(1, lagk100[0:19][]', 0, 1, 1);
	DrawTitle(1, "Dynamiske multiplikatorer");
	DrawT(2, imlrm100[0:19][]', 0, 1, 1);
	DrawTitle(2, "Interimmult. & langtidsmult.");
    DrawT(3, stimmed[0:19][]', 0, 1, 1);
	DrawTitle(3, "Stand. interimmult. & 0.5-linja");
	ShowDrawWindow();   
}
